//+------------------------------------------------------------------+
//|                                           ind_FletChannel_07.mq4 |
//|                                            Copyright  2013, sv. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, sv."
#property link      "7009731@mail.ru"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
//----
extern int    Distans     = 100;      //      20
extern int    Channel     = 760;     //     1000
extern int    ZoneUnSence = 120;      //     ,   80
extern int    PauseBar    = 20;       //        ,  1
//----
double Up[];
double Down[];
double UpSupport[];
double DownResistance[];

double pnt;
double high,   low;
double high_1 = 0,
       low_1  = 0;
bool   up_chanel, dn_chanel, FirstChanel;
bool   DrawChannel = false;
int    limit,  History=0;        // 0-  
int    Bar;

//+------------------------------------------------------------------+
int init() 
  {
//----      
   SetIndexBuffer(0,Up);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexEmptyValue(0,0.0);

   SetIndexBuffer(1,Down);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexBuffer(2,UpSupport);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexEmptyValue(2,0.0);

   SetIndexBuffer(3,DownResistance);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexEmptyValue(3,0.0);
//----      
   return(0);
  }
//+------------------------------------------------------------------+
int start() 
  { 
   Comment("DrawChannel =",DrawChannel,"\n",
           "limit =",limit);
  
   limit = Bars-IndicatorCounted()-1; 
   if(limit >= 1)                    limit = Bars-1;
   if(History!=0 && limit>History)  limit = History-1;                   // -   

   Bar = limit;
   
   // ------------------------------------------------------------------
   for(int i=limit; i>=0; i--) 
     {
      if(i < Bar-PauseBar)
       {
        //     ,  .
        if(DrawChannel==false)
         {
          //        Distans
          double low  = iLow (NULL,0,iLowest (NULL,0,MODE_LOW, Distans,i-1));
          double high = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Distans,i-1));
          
          //            Channel
          if( (high-low) < Channel*Point )  DrawChannel=true;
         }  
       }
      // ------------------------------------------------------------------
      if(DrawChannel)
       {  
        //          Distans
        
        //    
        if(FirstChanel) 
        { 
          if(Up[i-2]==0 && Down[i-2]==0)
          {
            Up[i-1]   = high;   
            Down[i-1] = low; 
          } 
          else
          {
            Up[i-1]   = Up[i-2];   
            Down[i-1] = Down[i-2]; 
          }  
        }
        if(up_chanel)   
        { 
          if(Up[i-2]==0 && UpSupport[i-2]==0)
          {
            Up[i-1]        = high;   
            UpSupport[i-1] = high - Channel*Point; 
          }
          else
          {
            Up[i-1]        = Up[i-2];   
            UpSupport[i-1] = UpSupport[i-2]; 
          }  
        }   //    
        if(dn_chanel)   
        { 
          if(Down[i-2]==0 && DownResistance[i-2]==0)
          {
            Down[i-1] = low;    
            DownResistance[i-1] = low  + Channel*Point; 
          } 
          else
          {
            Down[i-1] = Down[i-2];    
            DownResistance[i-1] = DownResistance[i-2]; 
          } 
        }   //    
        
        //     
        // ------------------------------------------------------------------
        if( high_1==0 && low_1==0 )    
         {
          FirstChanel=true;  high_1=high;  low_1=low; 
         }
        else                     //        
         { 
          if(high > high_1)      //          ,    
           {
            up_chanel=true;      //      
            high_1 = high;       //   
            low_1  = low;
           }
        
          if(low < low_1)        //          ,    
           {
            dn_chanel=true;      //      
            high_1=high;         //   
            low_1=low;
           }
         }  
        // ------------------------------------------------------------------
        
        if(Up[i]!=0 && UpSupport[i]!=0)        //   ,    
         {
          if ((Close[i-1] > Up[i-1]        + ZoneUnSence*Point) ||
              (Close[i-1] < UpSupport[i-1] - ZoneUnSence*Point))
           {
            //    ,   - ..     
            up_chanel=false;
            dn_chanel=false;
            FirstChanel=false; 
            DrawChannel=false;
           }
         } 
        // ------------------------------------------------------------------
        if(Down[i-1]!=0 && DownResistance[i-1]!=0)
         {
          if ((Close[i-1] > DownResistance[i-1]+ZoneUnSence*Point) ||
              (Close[i-1] < Down[i-1]-ZoneUnSence*Point))
           {
            //    ,   - ..     
            up_chanel=false;
            dn_chanel=false;
            FirstChanel=false;
            DrawChannel=false;
           }
         }
        if(Up[i-1]!=0 && Down[i-1]!=0)
         {
          if ((Close[i-1] > Up[i-1]   + ZoneUnSence*Point) ||
              (Close[i-1] < Down[i-1] - ZoneUnSence*Point))
           {
            //    ,  
            up_chanel=false;
            dn_chanel=false;
            FirstChanel=false; 
            DrawChannel=false;
           }
         }    
        Bar = i; 
       }    
     } 
   //  
   // ------------------------------------------------------------------
   return(0);
  }
//+------------------------------------------------------------------+